<!DOCTYPE html>
<html lang=en>
<head>
  <title>Demo: Drag and Drop files</title>
  <script type="module" src="/$/entry.mjs"></script>
  <link rel="stylesheet" href="/$/style/base.css" />
  <style>
    body {
        position: absolute;
        top: 0; left: 0; right: 0;
        margin: auto; 
        min-height: 100dvh;
        text-align: center;
        color: var(--color-text-body);

        &> #preview {
            &> img, video {
                max-height: 90vh;
                max-width: 80vw;
            }
        }
    }
  </style>
</head>
<body 
    ondrop="handleDrop(event);"
    ondragover="event.preventDefault();"
>
    <header href="/$/template/header.html"></header>
  <h1>Drag and drop files</h1>
  <div id="preview"></div>
<script type="text/javascript">
function handleDrop(event) {
    if (!(event instanceof DragEvent)) return;
    event.preventDefault()

    const $preview = document.getElementById('preview')

    Array.from(event.dataTransfer.items)
        .forEach((item, i) => {
            console.log('item:', item)
            switch(item.kind) {
                case 'file': {
                    const file = item.getAsFile()
                    console.log('file:', file)
                    if (!file) return;
                    const { type } = file;
                    switch (type.split('/').at(0)) {
                        case 'image': {
                            if (i === 0) previewImage(file)
                            upload(file).then(({ Hash: cid }) => {
                                if (!cid) return;
                                console.log('uploaded:', `/ipfs/${cid}`)
                                if (i === 0) viewImage(getSrc(cid))
                            })
                            break;
                        }
                        case 'video': {
                            upload(file).then(({ Hash: cid }) => {
                                if (!cid) return;
                                console.log('uploaded:', `/ipfs/${cid}`)
                                if (i === 0)
                                    $preview.replaceChildren(
                                        renderVideo(getSrc(cid), {
                                            type, autoplay: true })
                                    )
                            }) 
                            break;
                        }
                    }
                    break;
                }
                case 'string': {
                    const text = item.getAsString(text => {
                        console.log('string:', text)
                    })
                }
            }
        })
    
    event.dataTransfer.items.clear()

    function previewImage(file) {
        const $img = $preview.querySelector('&> img')
            || document.createElement('img')
        if (!$img.isConnected) $preview.replaceChildren($img)
        else $img.removeAttribute('src')

        const reader = new FileReader()
        reader.readAsDataURL(file)
        reader.onloadend = () => {
            if (!$img.hasAttribute('src'))
                $img.setAttribute('src', reader.result)
        }
    }

    async function upload(file) {
        if (!('IPFS' in window)) return {};
        const body = new FormData()
        body.append('file', file, file.name)
        return await IPFS.rpc.add(body, {
            //? toFiles: location.pathname + file.name
        })
    }

    function getSrc(cid) {
        const http_url = `http://127.0.0.1:48084/ipfs/${cid}`
        const ipfs_url = `ipfs://${cid}`
        return http_url; //todo
    }

    function viewImage(src) {
        const $img = $preview.querySelector('&> img')
            || document.createElement('img')
        $img.setAttribute('src', src)
        if (!$img.isConnected)
            $preview.replaceChildren($img)
    }

    function renderElement(html, source=document) {
        source.createRange().createContextualFragment(html).firstElementChild
    }

    function renderVideo(src, options) {
        const $video = document.createElement('video')
        $video.setAttribute('controls', '')
        if (options?.autoplay)
            $video.setAttribute('autoplay', '')

        const $source = document.createElement('source')
        $source.setAttribute('src', src)
        if (options?.type) $source.setAttribute('type', options.type)
        $video.append($source)
        return $video
    }
}
</script>
</body>
</html>
